#ifndef RELATIONALSTORAGESERVICE_DATAELEMENT_H
#define RELATIONALSTORAGESERVICE_DATAELEMENT_H

#include "Reflex/Type.h"

namespace pool {

  namespace RelationalStorageService {

    // class describing an elementary part of data to be stored 
    class DataElement {
      public:
      DataElement();
      DataElement( size_t declaringScopeOffset, Reflex::OffsetFunction offsetFunction );
      virtual ~DataElement();

      DataElement& addChild( size_t declaringScopeOffset, Reflex::OffsetFunction offsetFunction );
      
      void setRefFlag();
      void setMetadata( size_t metadataIndex);
      size_t offset( const void* topLevelAddress ) const;
      void* address( const void* topLevelAddress ) const;
      bool hasMetadata() const;
      bool isRef() const;
      size_t metadataIndex() const;
      size_t declaringScopeOffset() const;

      private:

      const DataElement* m_parent;
      std::vector<DataElement*> m_children;
      size_t m_declaringScopeOffset;
      Reflex::OffsetFunction m_offsetFunction;
      int m_metadataIndex;
      bool m_isRef;
      bool m_hasMetadata;
      
    };
  }
  
}

#endif

