#include "PoolContainerManagerFactory.h"
#include "PoolPrimitivesContainerManager.h"
#include "PoolHomogeneousContainerManager.h"
#include "PoolPolymorphicContainerManager.h"

pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newPrimitivesContainer( int containerId,
                                                                                     coral::ISchema& schema,
                                                                                     const std::string& containerTableName )
{
  return new pool::RelationalStorageService::PoolPrimitivesContainerManager( containerId,
                                                                             schema, 
                                                                             containerTableName );
}


pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newHomogeneousContainer( int containerId,
                                                                                      const std::string& containerName,
                                                                                      const std::string& className,
                                                                                      const std::string& creationMappingVersion,
                                                                                      coral::ISchema& schema,
                                                                                      MappingSequence& mappingSequences,
                                                                                      pool::Properties& dbProperties)
{
  return new pool::RelationalStorageService::PoolHomogeneousContainerManager( containerId,
                                                                              containerName,
                                                                              className,
                                                                              creationMappingVersion,
                                                                              schema,
                                                                              mappingSequences,
                                                                              dbProperties);
}


pool::RelationalStorageService::PoolBaseContainerManager*
pool::RelationalStorageService::PoolContainerManagerFactory::newPolymorphicContainer( int containerId,
                                                                                      const std::string& containerName,
                                                                                      coral::ISchema& schema,
                                                                                      const std::string& containerTableName,
                                                                                      pool::RelationalStorageService::MappingSequence& mappingSequences )

{
  return new pool::RelationalStorageService::PoolPolymorphicContainerManager( containerId,
                                                                              containerName,
                                                                              schema,
                                                                              containerTableName,
                                                                              mappingSequences );
}
